# papermc-api
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 2024.01
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import papermc_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import papermc_api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import papermc_api
from papermc_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.papermc.io
# See configuration.py for a list of all supported configuration parameters.
configuration = papermc_api.Configuration(
    host = "https://api.papermc.io"
)



# Enter a context with an instance of the API client
with papermc_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = papermc_api.DownloadControllerApi(api_client)
    project = 'paper' # str | The project identifier.
    version = 'version_example' # str | A version of the project.
    build = 56 # int | A build of the version.
    download = 'download_example' # str | A download of the build.

    try:
        # Downloads the given file from a build's data.
        api_response = api_instance.download(project, version, build, download)
        print("The response of DownloadControllerApi->download:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DownloadControllerApi->download: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.papermc.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DownloadControllerApi* | [**download**](docs/DownloadControllerApi.md#download) | **GET** /v2/projects/{project}/versions/{version}/builds/{build}/downloads/{download} | Downloads the given file from a build&#39;s data.
*ProjectControllerApi* | [**project**](docs/ProjectControllerApi.md#project) | **GET** /v2/projects/{project} | Gets information about a project.
*ProjectsControllerApi* | [**projects**](docs/ProjectsControllerApi.md#projects) | **GET** /v2/projects | Gets a list of all available projects.
*VersionBuildControllerApi* | [**build**](docs/VersionBuildControllerApi.md#build) | **GET** /v2/projects/{project}/versions/{version}/builds/{build} | Gets information related to a specific build.
*VersionBuildsControllerApi* | [**builds**](docs/VersionBuildsControllerApi.md#builds) | **GET** /v2/projects/{project}/versions/{version}/builds | Gets all available builds for a project&#39;s version.
*VersionControllerApi* | [**version**](docs/VersionControllerApi.md#version) | **GET** /v2/projects/{project}/versions/{version} | Gets information about a version.
*VersionFamilyBuildsControllerApi* | [**family_builds**](docs/VersionFamilyBuildsControllerApi.md#family_builds) | **GET** /v2/projects/{project}/version_group/{family}/builds | Gets all available builds for a project&#39;s version group.
*VersionFamilyControllerApi* | [**family**](docs/VersionFamilyControllerApi.md#family) | **GET** /v2/projects/{project}/version_group/{family} | Gets information about a project&#39;s version group.


## Documentation For Models

 - [BuildResponse](docs/BuildResponse.md)
 - [BuildsResponse](docs/BuildsResponse.md)
 - [Change](docs/Change.md)
 - [Download](docs/Download.md)
 - [ProjectResponse](docs/ProjectResponse.md)
 - [ProjectsResponse](docs/ProjectsResponse.md)
 - [VersionBuild](docs/VersionBuild.md)
 - [VersionFamilyBuild](docs/VersionFamilyBuild.md)
 - [VersionFamilyBuildsResponse](docs/VersionFamilyBuildsResponse.md)
 - [VersionFamilyResponse](docs/VersionFamilyResponse.md)
 - [VersionResponse](docs/VersionResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




