# coding: utf-8

"""
    PaperMC API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr, field_validator
from pydantic import Field
from typing_extensions import Annotated
from papermc_api.models.version_family_build import VersionFamilyBuild
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class VersionFamilyBuildsResponse(BaseModel):
    """
    VersionFamilyBuildsResponse
    """ # noqa: E501
    project_id: Optional[Annotated[str, Field(strict=True)]] = None
    project_name: Optional[StrictStr] = None
    version_group: Optional[Annotated[str, Field(strict=True)]] = None
    versions: Optional[List[StrictStr]] = None
    builds: Optional[List[VersionFamilyBuild]] = None
    __properties: ClassVar[List[str]] = ["project_id", "project_name", "version_group", "versions", "builds"]

    @field_validator('project_id')
    def project_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"[a-z]+", value):
            raise ValueError(r"must validate the regular expression /[a-z]+/")
        return value

    @field_validator('version_group')
    def version_group_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"[0-9.]+-?(?:pre|SNAPSHOT)?(?:[0-9.]+)?", value):
            raise ValueError(r"must validate the regular expression /[0-9.]+-?(?:pre|SNAPSHOT)?(?:[0-9.]+)?/")
        return value

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of VersionFamilyBuildsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in builds (list)
        _items = []
        if self.builds:
            for _item in self.builds:
                if _item:
                    _items.append(_item.to_dict())
            _dict['builds'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of VersionFamilyBuildsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "project_id": obj.get("project_id"),
            "project_name": obj.get("project_name"),
            "version_group": obj.get("version_group"),
            "versions": obj.get("versions"),
            "builds": [VersionFamilyBuild.from_dict(_item) for _item in obj.get("builds")] if obj.get("builds") is not None else None
        })
        return _obj


